Open In App

Count equal element pairs in the given array

Improve
Improve
Like Article
Like
Save
Share
Report

Given an array arr[] of N integers representing the lengths of the gloves, the task is to count the maximum possible pairs of gloves from the given array. Note that a glove can only pair with a same-sized glove and it can only be part of a single pair.

Examples: 

Input: arr[] = {6, 5, 2, 3, 5, 2, 2, 1} 
Output:
Explanation: (arr[1], arr[4]) and (arr[2], arr[5]) are the only possible pairs.

Input: arr[] = {1, 2, 3, 1, 2} 
Output:

Simple Approach: Sort the given array so that all the equal elements are adjacent to each other. Now, traverse the array and for every element, if it is equal to the element next to it then it is a valid pair and skips these two elements. Else the current element doesn’t make a valid pair with any other element and hence only skips the current element.

Below is the implementation of the above approach:  

C++14




// C++ implementation of the approach
#include <bits/stdc++.h>
using namespace std;
 
// Function to return the maximum
// possible pairs of gloves
int cntgloves(int arr[], int n)
{
    // To store the required count
    int count = 0;
 
    // Sort the original array
    sort(arr, arr + n);
 
    for (int i = 0; i < n - 1;) {
 
        // A valid pair is found
        if (arr[i] == arr[i + 1]) {
            count++;
 
            // Skip the elements of
            // the current pair
            i = i + 2;
        }
 
        // Current elements doesn't make
        // a valid pair with any other element
        else {
            i++;
        }
    }
    return count;
}
 
// Driver code
int main()
{
    int arr[] = { 6, 5, 2, 3, 5, 2, 2, 1 };
    int n = sizeof(arr) / sizeof(arr[0]);
 
    // Function call
    cout << cntgloves(arr, n);
 
    return 0;
}


Java




// Java implementation of the approach
import java.util.*;
 
class GFG {
 
    // Function to return the maximum
    // possible pairs of gloves
    static int cntgloves(int arr[], int n)
    {
         
        // Sort the original array
        Arrays.sort(arr);
        int res = 0;
        int i = 0;
 
        while (i < n) {
             
            // take first number
            int number = arr[i];
            int count = 1;
            i++;
 
            // Count all duplicates
            while (i < n && arr[i] == number) {
                count++;
                i++;
            }
             
            // If we spotted number just 2
            // times, increment
            // result
            if (count >= 2) {
                res = res + count / 2;
            }
        }
        return res;
    }
 
    // Driver code
    public static void main(String[] args)
    {
 
        int arr[] = {6, 5, 2, 3, 5, 2, 2, 1};
        int n = arr.length;
 
        // Function call
        System.out.println(cntgloves(arr, n));
    }
}
 
// This code is contributed by Lakhan murmu


Python3




# Python3 implementation of the approach
 
# Function to return the maximum
# possible pairs of gloves
 
 
def cntgloves(arr, n):
 
    # To store the required count
    count = 0
 
    # Sort the original array
    arr.sort()
    i = 0
    while i < (n-1):
 
        # A valid pair is found
        if (arr[i] == arr[i + 1]):
            count += 1
 
            # Skip the elements of
            # the current pair
            i = i + 2
 
        # Current elements doesn't make
        # a valid pair with any other element
        else:
            i += 1
 
    return count
 
 
# Driver code
if __name__ == "__main__":
 
    arr = [6, 5, 2, 3, 5, 2, 2, 1]
    n = len(arr)
 
    # Function call
    print(cntgloves(arr, n))
 
    # This code is contributed by AnkitRai01


C#




// C# implementation of the approach
using System;
 
class GFG {
 
    // Function to return the maximum
    // possible pairs of gloves
    static int cntgloves(int[] arr, int n)
    {
        // To store the required count
        int count = 0;
 
        // Sort the original array
        Array.Sort(arr);
 
        for (int i = 0; i < n - 1;) {
 
            // A valid pair is found
            if (arr[i] == arr[i + 1]) {
                count++;
 
                // Skip the elements of
                // the current pair
                i = i + 2;
            }
 
            // Current elements doesn't make
            // a valid pair with any other element
            else {
                i++;
            }
        }
        return count;
    }
 
    // Driver code
    public static void Main(String[] args)
    {
        int[] arr = { 6, 5, 2, 3, 5, 2, 2, 1 };
        int n = arr.Length;
 
        // Function call
        Console.WriteLine(cntgloves(arr, n));
    }
}
 
// This code is contributed by Princi Singh


Javascript




<script>
 
    // Javascript implementation of the approach
 
    // Function to return the maximum
    // possible pairs of gloves
    function cntgloves(arr, n)
    {
          
        // Sort the original array
        arr.sort();
        let res = 0;
        let i = 0;
  
        while (i < n) {
              
            // take first number
            let number = arr[i];
            let count = 1;
            i++;
  
            // Count all duplicates
            while (i < n && arr[i] == number) {
                count++;
                i++;
            }
              
            // If we spotted number just 2
            // times, increment
            // result
            if (count >= 2) {
                res = res + Math.floor(count / 2);
            }
        }
        return res;
    }
 
     
    // Driver code
     
    let arr = [6, 5, 2, 3, 5, 2, 2, 1];
        let n = arr.length;
  
        // Function call
        document.write(cntgloves(arr, n));
  
 // This code is contributed by susmitakundugoaldanga.
</script>


Output

2

Time Complexity: O(N*log(N))
Auxiliary Space: O(1)

Efficient Approach 
1) Create an empty hash table (unordered_map in C++, HashMap in Java, Dictionary in Python) 
2) Store frequencies of all elements. 
3) Traverse through the hash table. For every element, find its frequency. Increment the result by frequency/2 for every element.

Below is the implementation of the above approach: 

C++




// C++ implementation of the approach
#include <bits/stdc++.h>
using namespace std;
 
// Function to return the maximum
// possible pairs of gloves
int cntgloves(int arr[], int n)
{
    unordered_map<int,int> m;
      
    // Traversing through the array
    for(int i = 0; i < n; i++)
    {
        // Counting frequency
        m[arr[i]] += 1;
    }
     
    // To store the required count
    int count = 0;
    for(auto it=m.begin();it!=m.end();it++)
    {
        count+=(it->second)/2;
    }
     
    return count;
}
 
// Driver code
int main()
{
    int arr[] = { 6, 5, 2, 3, 5, 2, 2, 1 };
    int n = sizeof(arr) / sizeof(arr[0]);
 
    // Function call
    cout << cntgloves(arr, n);
 
    return 0;
}
 
// This code was contributed by pushpeshrajdx01


Java




/*package whatever //do not write package name here */
 
import java.io.*;
import java.util.*;
 
class GFG{
    public static int cntgloves(int arr[], int n)
    {
       HashMap<Integer,Integer> hm =new HashMap<>();
      
       // Traversing through the array
       for(int i = 0; i < n; i++)
       {
          // Counting frequency
          hm.put(arr[i],hm.getOrDefault(arr[i],0)+1);
        }
     
       // To store the required count
       int count = 0;
       for(Map.Entry m : hm.entrySet())
       {   
           int val=(int)m.getValue();   
            count+=val/2;
        }
         
     
    return count;
}
    public static void main (String[] args) {
    int arr[] = { 6, 5, 2, 3, 5, 2, 2, 1 };
    int n = arr.length;
 
    // Function call
    System.out.println(cntgloves(arr, n));
 
     
    }
}


Python3




# Python implementation of the approach
 
# Function to return the maximum
# possible pairs of gloves
def cntgloves(arr, n):
    m = {}
      
    # Traversing through the array
    for i in arr:
        # Counting frequency
        if i not in m:
            m[i] = 0
        m[i] += 1
     
    # To store the required count
    count = 0
    for it in m :
        count += (m[it])//2
     
    return count
 
# Driver code
def main():
    arr = [6, 5, 2, 3, 5, 2, 2, 1]
    n = len(arr)
 
    # Function call
    print(cntgloves(arr, n))
 
if __name__ == "__main__":
    main()
 
# This code is contributed by shubhamsingh


C#




// C# implementation of the approach
using System;
using System.Collections.Generic;
 
class GFG{
  public static int cntgloves(int[] arr, int n)
  {
    Dictionary<int,int> hm = new Dictionary<int,int>();
 
    // Traversing through the array
    for(int i = 0; i < n; i++)
    {
       
      // Counting frequency
      if(hm.ContainsKey(arr[i]))
      {  
        hm[arr[i]]= hm[arr[i]]+1;
      }
      else
        hm.Add(arr[i], 1);
    }
 
    // To store the required count
    int count = 0;
    foreach(var m in hm)
    {
      int val = m.Value;
      count += val/2;
    }
 
    return count;
  }
  static public void Main () {
    int[] arr = { 6, 5, 2, 3, 5, 2, 2, 1 };
    int n = arr.Length;
 
    // Function call
    Console.WriteLine(cntgloves(arr, n));
  }
}
 
// This code is contributed by Aman Kumar


Javascript




// Javascript implementation of the approach
 
 
// Function to return the maximum
// possible pairs of gloves
function cntgloves(arr, n)
{
    var m = {};
      
    // Traversing through the array
    for(let i = 0; i < n; i++)
    {
        // Counting frequency
        if (m[arr[i]] === undefined)
            m[arr[i]] = 0
        m[arr[i]] += 1;
    }
     
    // To store the required count
    let count = 0;
    for(let it in m)
    {
        count+=Math.floor(m[it]/2);
    }
     
    return count;
}
 
// Driver code
arr = [ 6, 5, 2, 3, 5, 2, 2, 1 ];
n = arr.length;
 
// Function call
console.log(cntgloves(arr, n));
 
// This code is contributed by Pushpesh Raj


Output

2

Time Complexity: O(N)
Auxiliary Space: O(N)



Last Updated : 27 Jan, 2023
Like Article
Save Article
Previous
Next
Share your thoughts in the comments
Similar Reads